#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <string.h>
#include <time.h>
#include <arpa/inet.h>
#include <netdb.h>
#include "scolang_stdlib.h"
#include <curl/curl.h>
#include <curl/easy.h>


int print(char *s){
  printf("%s", s);
  printf("\n");
  return 1;
}

static void die(const char* msg) {
    fprintf(stderr, "%s", msg);
    exit(1);
}

int bind_val(int(*listener)(),void(*action)())
{
  if(fork() == 0){
    return 1;
  }
  else{
    int resolve = 0;
    if((*listener)())
    {
      resolve = 1;
      (*action)();
    }
    exit(0);
  }
}

int bind_port(int(*listener)(int),void(*action)(), int port)
{
  int resolve = 0;
  if((*listener)(port))
  {
    resolve = 1;
    (*action)();
  }
  return resolve;
}

int bind_p(int(*listener)(int),void(*action)())
{

  int lower = 1000;
  int upper = 9999;
  int port = 0;
  srand(time(NULL));
  port = rand() % upper;

  if(port < lower)
  {
    port += lower;
  }
  fprintf(stderr, "listening on port numbr: %d \n",port);

  int resolve = 0;
  if((*listener)(port))
  {
    resolve = 1;
    (*action)();
  }
  return resolve;
}

int webhook(int port_user)
{
  int sockfd;
  int resolve;
  struct sockaddr_in self;
  char buffer[1024];

  int lower = 1000;
  int upper = 9999;
  int port = 0;

  srand(time(NULL));
  port = port_user;
  if(port < lower)
  {
    port += lower;
  }
  fprintf(stderr,"\nlistening on port number: %d \n",port);

  resolve = 0;
  sockfd = socket(AF_INET,SOCK_STREAM,0);
  bzero(&self,sizeof(self));
  self.sin_family = AF_INET;
  self.sin_port = htons(port);
  self.sin_addr.s_addr = INADDR_ANY;

  if(bind(sockfd, (struct sockaddr*)&self, sizeof(self)) != 0)
    {
        perror("socket--bind");
        exit(errno);
    }

  if(listen(sockfd,20) != 0)
  {
      perror("socket--listen");
      exit(errno);
  }

  int response;
  struct sockaddr_in client_addr;
  int addrlen=sizeof(client_addr);
  response = accept(sockfd, (struct sockaddr*)&client_addr, &addrlen);

  if(response > 0)
  {
    resolve = 1;

  }
  close(response);
  close(sockfd);
  return resolve;
}

/*int query(char* query_string)
{
    int sock;
    struct sockaddr_in server_addr;
    struct hostent *he;
    char buf[4096];
    char server_name[200];
    char *server_ip;
    char *serverPort;
    char filePath[200];
    char *fname;
    int i;
    for(i=0;i<strlen(query_string);i++){
        if(query_string[i]=='/')
	    break;
    }
    memset(server_name, '\0', sizeof(server_name));
    strncpy(server_name, query_string, i);
    server_name[i] = '\0';
    memset(filePath, '\0', sizeof(filePath));
    strcpy(filePath, strchr(query_string, '/'));
    if((he = gethostbyname(server_name))==NULL){
	    die("gethostbyname failed");
    }

    server_ip = inet_ntoa(*(struct in_addr *)he->h_addr);
    if ((sock= socket(PF_INET, SOCK_STREAM, IPPROTO_TCP))<0) {
        die("socket failed");
    }

    memset(&server_addr, 0, sizeof(server_addr));
    server_addr.sin_family = AF_INET;
    server_addr.sin_addr.s_addr = inet_addr(server_ip);
    server_addr.sin_port = htons(80);

    if(connect(sock, (struct sockaddr *)&server_addr, sizeof(server_addr))<0){
	     die("connect failed");
     }

    snprintf(buf, sizeof(buf), "GET %s HTTP/1.1\r\n"
		    	      "Host: %s:%s\r\n"
		      	      "\r\n",
		    filePath, server_name, "80");
    if(send(sock, buf, strlen(buf), 0) != strlen(buf)){
        die("send failed");
    }

    FILE *f;
    if((f=fdopen(sock, "r"))==NULL) {
        die("fopen failed");
    }

    if(fgets(buf, sizeof(buf), f)==NULL){
        if(ferror(f)){
	         die("IO error");
	     }
	     else {
      	   fprintf(stderr, "server terminated connection without response");
      	   fclose(f);
      	   exit(1);
	     }
     }
     if (strncmp("HTTP/1.0 ", buf, 9) != 0 && strncmp("HTTP/1.1 ", buf, 9) != 0) {
         fprintf(stderr, "unknown protocol response: %s\n", buf);
	       fclose(f);
         exit(1);
    }
    char response_code[4];
    memset(response_code, '\0', sizeof(response_code));
    strncpy(response_code, (buf+9), 3);
    response_code[3] = '\0';
    fclose(f);
    return atoi(response_code);
}*/
int query(char* make_query) {
    char *query = malloc(1000);
    strcpy(query, make_query);
    char *endpoint = strtok(query," ");
    char *method = strtok(NULL, " ");
    char *raw_data = strtok(NULL," ");
    curl_global_init(CURL_GLOBAL_ALL);
    CURL *hnd = curl_easy_init();

    curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, method);
    curl_easy_setopt(hnd, CURLOPT_URL, endpoint);

    struct curl_slist *headers = NULL;
    headers = curl_slist_append(headers, "Postman-Token: 80f28757-6ef8-4444-abac-7dcb1dd7b204");
    headers = curl_slist_append(headers, "cache-control: no-cache");
    curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers);

    curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, raw_data);

    CURLcode ret = curl_easy_perform(hnd);
    free(query);
    return 1;
}

int system_call(char* query_string)
{
  return system(query_string);
}
